// sleep_hundredths(int); function will support sleeping up to 30 seconds.
// sleep time passed in must be in hundredths, NOT seconds.
// For example, to sleep 2 seconds, you would call sleep_hundredths(200);
//              to sleep 2.5 seconds, you would call sleep_hundredths(250);

#include <dos.h>

void sleep_hundredths(int hundredths)
{
    struct dostime_t time;
    int start_hsecond;
    int stop_hsecond;
    int start_second;
    int current_hsecond;
    int weight;

    if (hundredths <= 0) {
        return;
    }
    if (hundredths > 3000) {
        hundredths = 3000;
    }
    _dos_gettime(&time);
    start_hsecond = time.hsecond;
    stop_hsecond = start_hsecond + hundredths;
    start_second = time.second;
    while (1) {
        switch_task();
        _dos_gettime(&time);
        if (time.second < start_second) {
            time.second += 60;
        }
        weight = time.second - start_second;
        current_hsecond = time.hsecond + (weight * 100);
        if (current_hsecond > stop_hsecond) {
            break;
        }
    }
}
